//UCvaliant.java - Valiant's Universal Circuit based on universal graphs
//Copyright (c) 2007 Thomas Schneider
//See full Copyright license terms in file ../GPL.txt

package SFE.PF;

import SFE.BOAL.Gate;

/**
 * Valiant's Universal Circuit based on universal graphs.
 * <p>
 * This universal circuit is not implemented.
 * <p>
 * See <a href="http://portal.acm.org/citation.cfm?id=803649">Leslie G. Valiant, "Universal circuits (Preliminary Report)"</a>.
 *
 * @author Thomas Schneider
 */
public class UCvaliant extends UC {
	private static final long serialVersionUID = 1L;

	public int countGates() {
		logger.error("countGates() unimplemented.");
		return 0;
	}
	
	public int estimateGates(int ins, int outs, int gates) {
		double log_gates_ex=Math.log(gates*1.0)/Math.log(2.0);
		int log_gates=(int)Math.ceil(log_gates_ex);		
		int estimated=(int)((19*gates + 9.5*(ins+outs))*log_gates);
		return estimated;
	}

	public Gate[] extractCircuit(Gate[] outputs) {
		logger.error("extractCircuit() unimplemented.");
		return null;
	}

	public void generate(int u, int v, int k) {
		logger.error("generate() unimplemented.");		
		is_generated=false;
	}

	public void program(int[] ins, int[] outs, ParseGate[] gates) {
		logger.error("program() unimplemented.");
	}
	
	public UCvaliant() {
		is_implemented=false;
	}
}
